"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _draftJs = require("draft-js");

var _modifyBlock = _interopRequireDefault(require("./modifyBlock"));

var _toggleBlockStyle = _interopRequireDefault(require("./toggleBlockStyle"));

var _getCurrentBlock = _interopRequireDefault(require("./utils/getCurrentBlock"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var changeBlockType = function changeBlockType(editorState, blockType, data) {
  var block = (0, _getCurrentBlock["default"])(editorState);
  var currentBlockType = block.get('type');

  if (currentBlockType === blockType) {
    return (0, _modifyBlock["default"])(editorState, data);
  } else {
    return data ? (0, _toggleBlockStyle["default"])(editorState, {
      type: blockType,
      data: data
    }) : _draftJs.RichUtils.toggleBlockType(editorState, blockType);
  }
};

var _default = changeBlockType;
exports["default"] = _default;