"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getEntitiesForBlock = function getEntitiesForBlock(editorState, contentBlock) {
  var type = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  var content = editorState.getCurrentContent();
  var entities = [];
  var selectedEntity = null;
  contentBlock.findEntityRanges(function (character) {
    if (character.getEntity() !== null) {
      var entity = content.getEntity(character.getEntity());

      if (!type || type && entity.getType() === type) {
        selectedEntity = {
          entityKey: character.getEntity(),
          blockKey: contentBlock.getKey(),
          entity: content.getEntity(character.getEntity())
        };
        return true;
      }
    }

    return false;
  }, function (start, end) {
    entities.push(_objectSpread(_objectSpread({}, selectedEntity), {}, {
      start: start,
      end: end
    }));
  });
  return entities;
};

var _default = getEntitiesForBlock;
exports["default"] = _default;