"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ = require(".");

var _numbers = require("./utils/numbers");

var getEntitiesForCurrentBlock = function getEntitiesForCurrentBlock(editorState) {
  var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  return (0, _.getEntitiesForBlock)(editorState, (0, _.getCurrentBlock)(editorState), type);
};

var getEntitiesForSelection = function getEntitiesForSelection(editorState) {
  var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var entities = getEntitiesForCurrentBlock(editorState, type);
  var selection = editorState.getSelection();
  var selectionStart = selection.isCollapsed() ? selection.getStartOffset() - 1 : selection.getStartOffset();
  var selectionEnd = selection.getEndOffset();
  return entities.filter(function (_ref) {
    var start = _ref.start,
        end = _ref.end;
    return (0, _numbers.rangesOverlap)(selectionStart, selectionEnd, start, end);
  });
};

var _default = getEntitiesForSelection;
exports["default"] = _default;