"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _draftJs = require("draft-js");

var _ = require(".");

var insertEntity = function insertEntity(editorState, text, type, data) {
  var mutability = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 'MUTABLE';
  var selectedText = (0, _.getSelectedText)(editorState);
  var contentState = editorState.getCurrentContent();
  var selection = editorState.getSelection();
  var textWithSpace = text.concat(' ');
  var newContent = selectedText ? _draftJs.Modifier.replaceText(contentState, selection, text) : _draftJs.Modifier.insertText(contentState, selection, textWithSpace);
  var newContentWithEntity = newContent.createEntity(type, mutability, data, false);
  var entityKey = newContentWithEntity.getLastCreatedEntityKey();
  var anchorOffset = selection.getAnchorOffset();
  var newSelection = new _draftJs.SelectionState({
    anchorKey: selection.getAnchorKey(),
    anchorOffset: anchorOffset,
    focusKey: selection.getAnchorKey(),
    focusOffset: anchorOffset + text.length
  });

  var newContentWithLink = _draftJs.Modifier.applyEntity(newContentWithEntity, newSelection, entityKey);

  var withLinkText = _draftJs.EditorState.push(editorState, newContentWithLink, 'insert-characters');

  return _draftJs.EditorState.forceSelection(withLinkText, newContent.getSelectionAfter());
};

var _default = insertEntity;
exports["default"] = _default;